/* ***** BEGIN LICENSE BLOCK *****
 * Version: GPL 2.0
 *
 * This code is part of DownThemAll! - dTa!
 * Copyright © 2004-2006 Federico Parodi and Stefano Verna.
 * 
 * See notice.txt and gpl.txt for details.
 *
 * Contributers:
 *   Nils Maier <MaierMan@web.de>
 *
 * ***** END LICENSE BLOCK ***** */

var dropDowns = new Object();
var strbundleB, strbundle;

function checkSyntax() {
	
	// let's check and create the directory
	var f = new filePicker();
	var directory = document.getElementById("directory");
	if (!directory.value || directory.value.trim().length == 0) return false;
	
	if (f.createValidDestination(directory.value)==false) {
		alert(strbundleB.getString("destination"));
		var newDir = f.getFolder(null, strbundle.getString("validdestination"));
		if (!newDir) 
			directory.value="";
		else
			directory.value = newDir;
		return false;
	}
	dropDowns.directory.saveCurrent(false);
	return true;
}

function addURLnow(start) {
try {
		var url = document.getElementById("URLaddress").value;
		var ref = document.getElementById("URLref").value;
		
    if (DTA_AddingFunctions.isLinkOpenable(url) && checkSyntax()) {
			var num = Preferences.get("extensions.dta.numistance", 1);
			num = (num<999)?(++num):1;
			Preferences.set("extensions.dta.numistance", num);
			
			var address = document.getElementById("URLaddress");
			var url = address.value;
			if (address.hasAttribute('_realURL'))	{
				var url = { url: address.getAttribute('_realURL'), usable: address.value };
			}
			
			var el = {
				'url': url,
				'numIstance': num,
				'refPage': document.getElementById("URLref").value,
				'description': window.arguments ? window.arguments[0].description : '',
				'ultDescription': '',
				'mask': dropDowns.renaming.getCurrent(),
				'dirSave': dropDowns.directory.getCurrent()
			};
			
			DTA_AddingFunctions.sendToDown(start, [el]);
			
			dropDowns.directory.saveCurrent(false);
			dropDowns.renaming.saveCurrent(false);
			dropDowns.renaming.saveDrop(dropDowns.renaming.getCurrent());
			dropDowns.directory.saveDrop(dropDowns.directory.getCurrent());
			
			window.close();
			return true;
    } else {
			alert(strbundleB.getString("correctness"));
			return false;
    }
} catch(e) {DTA_debug.dump("addURLnow(): ", e);}
}

function load() {try {
		strbundleB = document.getElementById("strings");
		strbundle = document.getElementById("string");
		
		document.getElementById("directory").addEventListener("blur", checkSyntax, true);
		
		dropDowns.renaming = new dropDownObject("renaming", "renaming", "renamingitems", "*name*.*ext*", "*name*.*ext*|@|*num*_*name*.*ext*|@|*url*/*name*.*ext*|@|*name* (*text*).*ext*|@|*name* (*hh*-*mm*).*ext*");
		dropDowns.renaming.load();
		dropDowns.directory = new dropDownObject("directory", "directory", "directoryitems", "", "");
		dropDowns.directory.load();
		
		// if we know the file to download
		if (window.arguments) {
			var e = window.arguments[0];
			
			if (!e.url.url) {
				document.getElementById("URLaddress").value = e.url;
			} else {
				document.getElementById("URLaddress").value = e.url.usable;
				// this dialog was fired up with a predefined url.
				// changing it would invalidate the usable part of it.
				// so making it readonly is the only option.
				// if a users want to edit it then he should copy/paste the url. :p
				// XXX: reflect readonly state in css
				document.getElementById("URLaddress").setAttribute('_realURL', e.url.url);
				document.getElementById("URLaddress").readonly = true;
			}
			
			var refPage = DTA_AddingFunctions.isLinkOpenable(e.refPage) ? e.refPage : null;
			if (refPage) {
				try	{
						refPage = decodeURIComponent(refPage);
				} catch (ex) {}
				document.getElementById("URLref").value	 = refPage;
			}
		} else {
			// check if there's some URL in clipboard
			var clip = Components.classes["@mozilla.org/widget/clipboard;1"].getService(Components.interfaces.nsIClipboard);
			var trans = Components.classes["@mozilla.org/widget/transferable;1"].createInstance(Components.interfaces.nsITransferable);
			trans.addDataFlavor("text/unicode");
			clip.getData(trans, clip.kGlobalClipboard);
			var str=new Object();
			var strLength=new Object();
			trans.getTransferData("text/unicode",str,strLength);
			if (str) {
				str=str.value.QueryInterface(Components.interfaces.nsISupportsString);
				pastetext=str.data.substring(0,strLength.value / 2);
				if (pastetext.length > 0 && (/^(http|ftp)/).test(pastetext)) {
					document.getElementById("URLaddress").value = pastetext;
					document.getElementById("URLaddress").select();
				}
			}
		}
		
	} catch(e) {
	Debug.dump("load():", e);
	}
}

function browseDire() {
	// let's check and create the directory
	var f = new filePicker();
	var newDir = f.getFolder(document.getElementById("directory").value, strbundle.getString("validdestination"));
	if (newDir) document.getElementById("directory").value = newDir;
	
	var directory = document.getElementById("directory");
	checkSyntax();
	dropDowns.directory.saveCurrent(false);
}

function appendTag(event) {
	var text = document.getElementById(dropDowns.renaming.idInput);
	var s = text.inputField.selectionStart;
	text.value = text.value.substring(0, s) + event.target.getAttribute("value") + text.value.substring(text.inputField.selectionEnd, text.value.length);
	text.inputField.setSelectionRange(s + event.target.getAttribute("value").length, s + event.target.getAttribute("value").length);
}

var listObserver = {
  onDragStart: function (evt,transferData,action){
    var txt=evt.target.getAttribute("value");
    transferData.data=new TransferData();
    transferData.data.addDataForFlavour("text/unicode", txt);
  }
}

function unload() {
}

window.addEventListener("load", function() {setTimeout("window.sizeToContent();",0);}, false);
